// Kozak's KanJi Converter V1.16 by N's LAB  Copyright (C) 2006-2011 by Nobumichi Kozawa
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;
//import javax.microedition.io.*;
import java.io.*;

public class KKJConv extends MIDlet implements CommandListener, ItemCommandListener
{
    private RomaConv rconv;
    private Jisho js;
    private static SpeCharSel sp = null;
    public static EditScreen edit;
    public TextBox tb;
    private Command exitCommand, insCommand, chgCommand, addCommand, copyCommand, clrCommand, modeCommand, speCommand, loadCommand, saveCommand, smsCommand, qsaveCommand, qloadCommand;
    private Command tbBackCommand, tbBack2Command, tbCountCommand, tbClrCommand, tbAboutCommand, tbCacheStatCommand, tbCachePrintCommand, tbCopyCommand;
    private Command spCanCommand;
    private Command foOpenCommand, foCanCommand, foFileCommand, foRefreshCommand;
    public static Display disp;
    public StringBuffer sbKakutei;
    private StringBuffer sbRomaji, sbHiragana;
    private RomajiBuffer rbuff;
    private String sHiraganaYomi;
    private int iKakuteiPos, iHiraPos, iScreenPos, iHiraStart, iHiraEnd;
    private int iMargin = 5;
    public int iMode = 2;
    private String sMode;
    private String sPlatform;
    private String sKJKouho;
    public boolean bE61, bBB, bSonyEricsson, bE61old, bFreedom, bSonyEricssonKeyAssist, bNokia;
    public boolean bE7_00, bN97mini;
    public String sFirmVer;
    public static boolean bCN = false;
    public boolean bStrictShiftMode; // mainly, this is for E7-00
//    private boolean bModeChange, bInputInhibit, bKJinProc, bNeedSetWord, bCombConvMode, bE61Num2dConv;
    private boolean bInputInhibit, bKJinProc, bNeedSetWord, bCombConvMode, bE61Num2dConv;
    private int iShift, iE61NumLock;
    private boolean bShift, bBLShift;    // bBLShift = BlackBerry Left Shift
    private boolean bShiftPressing = false;     // This would be true which shift key is pressed
    private boolean bCtrlPressing = false;      // for Nokia Asha 303
    private boolean bSymPressing = false;       // for Nokia Asha 303
    public Font font;
    public char cParaSepa;
    private int iKigouPanel;
    public static int iWidth, iHeight;
    public int iSpChr;
    public int iBGColor, iTitleColor, iFontColor;
    public int iInsKey, iAddKey, iCopyKey, iModeKey, iKJModeKey, iQuickLoadKey, iQuickSaveKey;
    public byte bKJFont, bSPFont, bTextSave, bOtherFlag, bSms;
    public static byte bUserDict;
    public static byte bNumUdic;
    private byte bTbMenuItem, bKjMenuItem, bIMode, bE61key, bListConv;
    private boolean bListConvMode, bTenKeyMode;
    private int iConvCount, iListConvPos, iListConvMax, iListConvSt, iListConvHeight;
    private String[] saListConv;
    private byte[] baE61spe = null;
    private FileOp fo = null;
    public String sSMSNumber, sSMSName;

    public KKJConv()
    {
        sPlatform = System.getProperty("microedition.platform");
        //sPlatform = "NokiaE61-1/0618.04.04";
        bNokia = sPlatform.startsWith("Nokia");
        bE61 = sPlatform.startsWith("NokiaE61");
        bBB = sPlatform.startsWith("RIM Wireless");
        bSonyEricsson = sPlatform.startsWith("SonyEricsson");
        bE7_00 = sPlatform.startsWith("NokiaE7-00");
        bN97mini = sPlatform.startsWith("NokiaN97-4");
        bSonyEricssonKeyAssist = sPlatform.startsWith("SonyEricssonM600") ||
                             sPlatform.startsWith("SonyEricssonP990") ||
                                 sPlatform.startsWith("SonyEricssonP1");
        sFirmVer = getFirmVer(sPlatform);
        bE61old = bE61 && sFirmVer.startsWith("0610");

        /* Test code */
//        bE61 = true;
//        bE61old = false;
        /* End of Test Code */

        disp = Display.getDisplay(this);
        cParaSepa = getParaSepa();
        rconv = new RomaConv();
        loadConfig();
        js = new Jisho();
        setting();
        speCommand = new Command("記号パネル", Command.ITEM, 1);
        qsaveCommand = new Command("クイック保管", Command.ITEM, 2);
        qloadCommand = new Command("クイック読込み", Command.ITEM, 3);
        smsCommand = new Command("SMS送信", Command.ITEM, 4);
        chgCommand = new Command("切替", Command.ITEM, 5);
        insCommand = new Command("挿入", Command.ITEM, 6);
        addCommand = new Command("追加", Command.ITEM, 7);
        copyCommand = new Command("新規追加", Command.ITEM, 8);
        saveCommand = new Command("ファイル保管", Command.ITEM, 9);
        loadCommand = new Command("ファイル読込み", Command.ITEM, 10);
        clrCommand = new Command("クリアー", Command.ITEM, 11);
        exitCommand = new Command("終了", Command.ITEM, 12);
        modeCommand = new Command("文字種", Command.BACK, 1);
        tbBack2Command = (bFreedom) ? new Command("切替", Command.ITEM, 1) : null;
        tbBackCommand = new Command("切替", Command.BACK, 1);
        tbAboutCommand = new Command("About", Command.ITEM, 2);
        tbCountCommand = new Command("文字数", Command.ITEM, 3);
        tbClrCommand = new Command("クリアー", Command.ITEM, 4);
        tbCopyCommand = new Command("コピーto漢字入力画面", Command.ITEM, 5);
        tbCacheStatCommand = new Command("Cache Status", Command.ITEM, 6);
        tbCachePrintCommand = new Command("Cache Print", Command.ITEM, 7);
        spCanCommand = new Command("キャンセル", Command.EXIT, 1);
        foOpenCommand = new Command("オープン", Command.ITEM, 1);
        foCanCommand = new Command("キャンセル", Command.EXIT, 1);
        foFileCommand = new Command("ファイル選択", Command.ITEM, 2);
        foRefreshCommand = new Command("再読込み", Command.ITEM, 3);

        tb = new TextBox("コピペ画面", null, 65535, TextField.ANY);
        tb.setCommandListener(this);
        tb.addCommand(tbBackCommand);
        if (bFreedom) tb.addCommand(tbBack2Command);
        tb.addCommand(tbAboutCommand);        // 2
        if (0 == (0x20 & bTbMenuItem)) tb.addCommand(tbCopyCommand);
        if (0 == (0x10 & bTbMenuItem)) tb.addCommand(smsCommand);
        if (0 == (0x01 & bTbMenuItem)) tb.addCommand(tbCountCommand);        // 3
        if (0 == (0x02 & bTbMenuItem)) tb.addCommand(tbClrCommand);            // 4
        if (0 == (0x04 & bTbMenuItem)) tb.addCommand(tbCacheStatCommand);    // 5
        if (0 == (0x08 & bTbMenuItem)) tb.addCommand(tbCachePrintCommand);    // 6
        tb.addCommand(exitCommand);            // 7

        edit = new EditScreen();
        edit.setCommandListener(this);
        addEditCommands();
        disp.setCurrent(edit);

        sp = new SpeCharSel(this);
        sp.setCommandListener(this);
        sp.addCommand(spCanCommand);

        sSMSNumber = sSMSName = sKJKouho = "";
        sbKakutei = new StringBuffer(js.sError);
        loadData();
        if (bE61) loadE61Data();
        iKakuteiPos = sbKakutei.length() - 1;
        iScreenPos = 0;
        sbHiragana = new StringBuffer();
        iHiraPos = -1;
        sbRomaji = new StringBuffer();
        rbuff = new RomajiBuffer();
        iMode = 2;
        bListConvMode = bInputInhibit = bKJinProc = false;
        iShift = iE61NumLock = 0;
        bE61Num2dConv = bBLShift = bShift = bTenKeyMode = false;
        iKigouPanel = 0;
        setSMode();
        udicError();
        edit.repaint();
        //if (!js.bLoadIndex) dispAbout(10000); no longer needed to display 'about' first time.
    }

    public void buffClear() {
        iKakuteiPos = -1;
        sbHiragana.delete(0, sbHiragana.length());
        iHiraPos = -1;
        sbRomaji.delete(0, sbRomaji.length());
        rbuff.deleteAll();
        bListConvMode = bKJinProc = bInputInhibit = false;
    }

    private void loadShortCut() {
        RecordStore rs = null;
        byte[] ba;

        try {
            rs = RecordStore.openRecordStore("KKJShortCut", false);
            ba = rs.getRecord(1);
            if (24 <= ba.length) {
                    iSpChr = ba2int(ba, 0);
                    iKJModeKey = ba2int(ba, 1);
                    iModeKey = ba2int(ba, 2);
                    iInsKey = ba2int(ba, 3);
                    iAddKey = ba2int(ba, 4);
                    iCopyKey = ba2int(ba, 5);
            }
            if (32 == ba.length) {
                    iQuickLoadKey = ba2int(ba, 6);
                    iQuickSaveKey = ba2int(ba, 7);
            }
        } catch (Exception e) {
        } finally {
            try {
                if (null != rs) rs.closeRecordStore();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    private int ba2int(byte[] ba, int pos) {
        int iWork = 0, offset = pos * 4;
    for (int i = offset + 3; i >= offset; i--) {
            iWork *= 128;
            iWork += ba[i];
    }
    return iWork;
    }

    private void loadE61Data() {
        baE61spe = new byte[27];
        InputStream in = getClass().getResourceAsStream("E61Spe" + bE61key + ".map");
        try {
            if (null == in) throw new IOException("E61 Keymap not found, ID = " + bE61key);
            in.read(baE61spe);
            in.close();
        } catch (IOException e) {
            baE61spe = null;
            js.sError = "loadE61Data " + e;
            e.printStackTrace();
        }
    }

    private void udicError() {
        if (js.sUdicErr != null) {
            Alert udicErr = new Alert("User Dictionary Error");
            udicErr.setTimeout(5000);
            udicErr.setType(AlertType.ERROR);
            udicErr.setString("" + js.sUdicErr);
            disp.setCurrent(udicErr);
        }
    }

    private String getFirmVer(String platform) {
        int i = platform.indexOf('/');
        if (0 <= i && i < platform.length() - 1) return platform.substring(i + 1);
        else return "";
    }

    private void loadConfig() {
        RecordStore rsc = null;
        byte[] ba;

        // Default set
        bKJFont = bSPFont = bE61key = 1;
        bIMode = bTextSave = bUserDict = bSms = 0;
        bKjMenuItem = setup.KKJSetup.bKjMenuDefault;
        bTbMenuItem = setup.KKJSetup.bTbMenuDefault;
        bListConv = 3;
        bNumUdic = 100;
        bOtherFlag = (byte)((bE7_00) ? 0x08 : 0);

        try {
            rsc = RecordStore.openRecordStore("KKJConfig", false);
            ba = rsc.getRecord(1);
            switch (ba.length) {
                case 12 : bSms = ba[11];
            case 11 : bNumUdic = ba[10];
            case 10 : bListConv = ba[9];
            case 9 : bE61key = ba[8];
            case 8 : bIMode = ba[7];
            case 7 : bKjMenuItem = ba[6];
            case 6 : bTbMenuItem = ba[5];
            case 5 : bUserDict = ba[4];
            case 4 : bOtherFlag = ba[3];
            case 3 : bTextSave = ba[2];
            case 2 : bSPFont = ba[1];
            case 1 : bKJFont = ba[0];
            }
        } catch (Exception e) {
        } finally {
            try {
            if (null != rsc) rsc.closeRecordStore();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        bFreedom = (1 == (0x01 & bOtherFlag));
        bSonyEricssonKeyAssist |= (4 == (0x04 & bOtherFlag));
        bStrictShiftMode = (8 == (0x08 & bOtherFlag));
    }

    private void setting()
    {
        if (bBB) {
            iFontColor = 0x00FFFFFF;    // White
            iBGColor = 0x00000000;        // Black
            iTitleColor = 0x00B0C4DE;     // lightsteelblue
        } else if (bCN) {
            iFontColor = 0x00FF0000;        // red
            iBGColor = 0x00FFFF00;            // yellow
            iTitleColor = 0x000000FF;        // blue;
        } else {
            iFontColor = 0x00FFFFFF;    // White
            iBGColor = 0x00000080;        // NAVY
            iTitleColor = 0x00FFFF00;    // yellow
        }
        if (bBB) {
            iSpChr = 128;                // SYM key?
        iInsKey = iModeKey = iKJModeKey = 0;
        iAddKey = 131;                // Alt+O
        iCopyKey = 132;                // Alt+P
        } else {
            iSpChr = 0x2f;    // '/'
            iInsKey = 9;    // Ctr+I
            iAddKey = 1;    // Ctr+A
            iCopyKey = 3;    // Ctr+C
        iModeKey = 24;    // Ctr+X
            iKJModeKey = 11;    // Ctr+K;
            iQuickLoadKey = 12; // Ctr+L
            iQuickSaveKey = 19; // Ctr+S
            loadShortCut();
        }
//        if (bE61 && !bE61old) {
//            iSpChr = 241;        // 0xF001, E61 new firmware
//        }
    }

    public void entSpeChar(char ch, boolean b)
    {
        int iHiraLen = sbHiragana.length();

           if (bKJinProc) {
            edit.kjKakutei();
            sbKakutei.insert(iKakuteiPos + 1, ch);
            iKakuteiPos++;
       } else if (0 < iHiraLen) {
            sbHiragana.append(ch);
            if (2 != iMode) {
                sbKakutei.insert(iKakuteiPos + 1, sbHiragana.toString());
           iKakuteiPos += iHiraLen + 1;
           sbHiragana.delete(0, iHiraLen + 1);
           iHiraPos = - 1;
           sbRomaji.delete(0, sbRomaji.length());
           rbuff.deleteAll();
            }
       } else {
            sbKakutei.insert(iKakuteiPos + 1, ch);
            iKakuteiPos++;
       }
        disp.setCurrent(edit);
    }

    public void clearTextBox() {
        if (0 < tb.size()) {
            tb.delete(0, tb.size());
        }
    }

    public void startApp(){ }
    public void pauseApp(){ }
    public void destroyApp(boolean unconditional)
    {
        js.storeCache();
        storeData();
    }

    public void commandAction(Command command, Item item) {
        if (command == foFileCommand) {
//            disp.setCurrent(fo.kfd.fileList);
            new Thread(new Runnable() {
                public void run() {
                    fo.kfd.openRoot2();
                }
            }).start();
            disp.setCurrent(fo.kfd.fileList);
        }
    }

    public void commandAction(Command command, Displayable screen) {
        if (command == exitCommand) {
            destroyApp(false);
            notifyDestroyed();
        } else if (command == smsCommand) {
            SendSMS sms = new SendSMS(disp, screen, this);
           sms.disp();
        } else if (command == chgCommand) {
            dispTb(0);
        } else if (command == insCommand) {
            dispTb(1);
        } else if (command == addCommand) {
            dispTb(2);
        } else if (command == copyCommand) {
            dispTb(3);
        } else if (command == clrCommand) {
            sbKakutei.delete(0, sbKakutei.length());
            buffClear();
/*            iKakuteiPos = -1;
            sbHiragana.delete(0, sbHiragana.length());
            iHiraPos = -1;
            sbRomaji.delete(0, sbRomaji.length());
            rbuff.deleteAll();
            bListConvMode = bKJinProc = bInputInhibit = false;*/
            edit.repaint();
        } else if (command == modeCommand) {
            changeMode(true);
            edit.repaint();
        } else if (command == speCommand) {
            disp.setCurrent(sp);
        } else if (command == saveCommand || command == loadCommand) {
/*            if (null == fo) {
                fo = new FileOp();
                if (null != fo.mainForm) {
                    fo.mainForm.addCommand(foOpenCommand);
                    fo.mainForm.addCommand(foCanCommand);
                    fo.mainForm.setCommandListener(this);
                    fo.siFile.setDefaultCommand(foFileCommand);
                    fo.siFile.setItemCommandListener(this);
                    fo.kfd.fileList.addCommand(foOpenCommand);
                    fo.kfd.fileList.addCommand(foCanCommand);
                    fo.kfd.fileList.addCommand(foRefreshCommand);
                    fo.kfd.fileList.setCommandListener(this);
                }
            }*/

            openFileOp();
            fo.setMode(command == saveCommand);
            disp.setCurrent(fo.mainForm);
        } else if (command == qsaveCommand || command == qloadCommand) {
            quickFile(command == qsaveCommand);
/*            openFileOp();
            boolean rc = true;
            if (command == qsaveCommand) rc = fo.quickSave(this);
            else if (command == qloadCommand) rc = fo.quickLoad(this);
            if (!rc && fo.sError != null) {
                   Alert foError = new Alert("File Open Error!");
                   foError.setTimeout(5000);
                   foError.setType(AlertType.ERROR);
                   foError.setString("" + fo.sError);
                   disp.setCurrent(foError);
            }*/
        } else if (command == tbBackCommand || command == tbBack2Command) {
            disp.setCurrent(edit);
        } else if (command == tbCopyCommand) {
            sbKakutei.delete(0, sbKakutei.length());
            buffClear();
            sbKakutei.append(getTbText());
            disp.setCurrent(edit);
        } else if (command == tbCountCommand) {
            dispTb(0);
        } else if (command == tbClrCommand) {
            clearTextBox();
//            tb.delete(0, tb.size());
        } else if (command == tbAboutCommand) {
            dispAbout(10000);
        } else if (command == tbCacheStatCommand) {
            //tb.delete(0, tb.size());
            clearTextBox();
            tb.insert(js.cacheStatusReport(cParaSepa), 0);
        } else if (command == tbCachePrintCommand) {
            //tb.delete(0, 0);
            clearTextBox();
            tb.insert(js.printCache(cParaSepa), 0);
        } else if (command == spCanCommand) {
            disp.setCurrent(edit);
        } else if (command == foCanCommand) {
            if (screen == fo.kfd.fileList) {
                disp.setCurrent(fo.mainForm);
            } else {
                disp.setCurrent(edit);
            }
        } else if (screen == fo.kfd.fileList) {
            if (command == foOpenCommand || command == List.SELECT_COMMAND) {
                if (fo.setOpenPath(command == List.SELECT_COMMAND)) disp.setCurrent(fo.mainForm);
            } else if (command == foRefreshCommand) {
                new Thread(new Runnable() {
                    public void run() {
                        fo.kfd.open("");
                    }
                }).start();
            }
        } else if (screen == fo.mainForm) {
            boolean rc = true;
            if (command == foOpenCommand) {
                if (!(rc = fo.open(this)) && fo.sError != null) {
                    Alert foError = new Alert("File Open Error!");
                    foError.setTimeout(5000);
                    foError.setType(AlertType.ERROR);
                    foError.setString("" + fo.sError);
                    disp.setCurrent(foError);
            }
            }
            if (rc) disp.setCurrent(edit);
        }

        bCtrlPressing = bSymPressing = bShift = false;
    }

    private void openFileOp()
    {
        if (null == fo) {
            fo = new FileOp();


            fo.kfd.dummyAccess();


            if (null != fo.mainForm) {
                fo.mainForm.addCommand(foOpenCommand);
                fo.mainForm.addCommand(foCanCommand);
                fo.mainForm.setCommandListener(this);
                fo.siFile.setDefaultCommand(foFileCommand);
                fo.siFile.setItemCommandListener(this);
                fo.kfd.fileList.addCommand(foOpenCommand);
                fo.kfd.fileList.addCommand(foCanCommand);
                fo.kfd.fileList.addCommand(foRefreshCommand);
                fo.kfd.fileList.setCommandListener(this);
            }
        }
    }

    public void quickFile(boolean bSave)
    {
        openFileOp();
        boolean rc = true;
        if (bSave) rc = fo.quickSave(this);
        else rc = fo.quickLoad(this);
            if (!rc && fo.sError != null) {
                Alert foError = new Alert("File Open Error!");
                foError.setTimeout(5000);
                foError.setType(AlertType.ERROR);
                foError.setString("" + fo.sError);
                disp.setCurrent(foError);
            }
    }

    private void dispAbout(int wait)
    {
           Alert about = new Alert("About KKJConv");
           about.setTimeout(wait);
           about.setType(AlertType.INFO);
           about.setString("Kozak's KanJi Converter v1.16, このプログラムは無料で配布しています。 Copyright (C) 2006-2012 by Nobumichi Kozawa http://www.nkozawa.com/blog/ platform=" + sPlatform);
           disp.setCurrent(about);
    }

    private char getParaSepa()
    {
        byte [] ps = new byte[3];
        String sP;
        // this is Paragrpah Separator in UTF-8
        ps[0] = (byte)-30; ps[1] = (byte)-128; ps[2] = (byte)-87;
        try {
            sP = new String(ps, "UTF-8");
            return sP.charAt(0);
        } catch (Exception e) {e.printStackTrace();}
        return 0x0a;
    }

    private void addEditCommands()
    {
        if (0 == (0x01 & bKjMenuItem)) edit.addCommand(speCommand);        // 1
        if (bNokia && 0 == (0x40 & bKjMenuItem)) {
            edit.addCommand(qsaveCommand);                        // quick save for ptsNotes
            edit.addCommand(qloadCommand);                        // quick load for ptsNotes
        }
        if (0 == (0x80 & bKjMenuItem)) edit.addCommand(smsCommand);
        if (0 == (0x02 & bKjMenuItem)) edit.addCommand(chgCommand);        // 2
        if (0 == (0x04 & bKjMenuItem)) edit.addCommand(insCommand);        // 3
        if (0 == (0x08 & bKjMenuItem)) edit.addCommand(addCommand);        // 4
        if (0 == (0x10 & bKjMenuItem)) edit.addCommand(copyCommand);    // 5
        if (0 == (0x20 & bKjMenuItem)) {
            edit.addCommand(saveCommand);
            edit.addCommand(loadCommand);
        }
        edit.addCommand(clrCommand);    // 8
        edit.addCommand(exitCommand);    // 9
        edit.addCommand(modeCommand);
    }

    private void dispTb(int cmd)
    {
        if (!bCN && 4 == sbKakutei.length()) {
            if ('し' == sbKakutei.charAt(0) && 'し' == sbKakutei.charAt(2) && 'ね' == sbKakutei.charAt(1) && 'ね' == sbKakutei.charAt(3)) {
                js.bCN = bCN = true;
                js.storeIndex();
            }
        }
        switch (cmd) {
            case 1 :    // Insert
                tb.insert(sbKakutei.toString(), tb.getCaretPosition());
                break;
            case 2 :    // Add
                tb.insert(sbKakutei.toString(), tb.size());
                break;
            case 3 :    // Copy
                //tb.delete(0, tb.size());
                clearTextBox();
                tb.insert(sbKakutei.toString(), 0);
                break;
            default :
        }
        tb.setTitle("コピペ画面 " + tb.getString().length());
        disp.setCurrent(tb);
        bCtrlPressing = bSymPressing = false;
    }

    public String getTbText() {
        StringBuffer sb = new StringBuffer();
        char[] cb = new char[tb.size()];
        tb.getChars(cb);
    boolean flg = false;

        for (int i = 0; i < cb.length; i++) {
            switch (cb[i]) {
                case '\r' :
                    sb.append(cParaSepa);
                    flg = true;
                    break;
        case '\n' :
                    if (flg) {
            flg = false;
            continue;
                    }
                    sb.append(cParaSepa);
                    break;
        default :
                    flg = false;
                    sb.append(cb[i]);
            }
        }
        return sb.toString();
    }

    private void changeMode(boolean bFwd)
    {
    if (bFwd) {
            if (bShift) {
                iMode = 2;
                iShift = 0;
            } else iMode++;

            if (3 == iMode && (0 != (0x04 & bIMode))) iMode++;
            if (4 == iMode && (0 != (0x08 & bIMode))) iMode++;
            if (5 == iMode && (0 != (0x10 & bIMode))) iMode++;
            if (6 == iMode && (0 != (0x20 & bIMode))) iMode++;
            if (bE61 || bTenKeyMode) {
                if (iMode < 0) iMode = 6;
                if (6 < iMode) iMode = 0;
            } else {
                if (iMode < 0) iMode = 4;
            if (4 < iMode) iMode = 0;
            }
            if (0 == iMode && (0 != (0x01 & bIMode))) iMode++;
            if (1 == iMode && (0 != (0x02 & bIMode))) iMode++;
    } else {
            iMode--;
            if (1 == iMode && (0 != (0x02 & bIMode))) iMode--;
            if (0 == iMode && (0 != (0x01 & bIMode))) iMode--;
            if (bE61 || bTenKeyMode) {
                if (iMode < 0) iMode = 6;
                if (6 < iMode) iMode = 0;
            } else {
               if (iMode < 0) iMode = 4;
               if (4 < iMode) iMode = 0;
            }
            if (6 == iMode && (0 != (0x20 & bIMode))) iMode--;
            if (5 == iMode && (0 != (0x10 & bIMode))) iMode--;
            if (4 == iMode && (0 != (0x08 & bIMode))) iMode--;
            if (3 == iMode && (0 != (0x04 & bIMode))) iMode--;
    }

           if (bKJinProc) edit.kjKakutei();
           setSMode();
    }

    private void setSMode()
    {
           switch (iMode) {
            case 0 : sMode = "全英"; break;
            case 1 : sMode = "半英"; break;
            case 2 : sMode = "漢字"; break;
            case 3 : sMode = "全カナ"; break;
            case 4 : sMode = "半カナ"; break;
            case 5 : sMode = (bE61) ? "全数記" : "全数"; break;
            case 6 : sMode = (bE61) ? "半数記" : "半数"; break;
           }
//           bModeChange = true;
    }

    private void loadData()
    {
        if (0 == bTextSave) {
            if (0 == sbKakutei.length()) {
                byte [] ba;
                RecordStore rsw = null, rsx = null;
        try {
                    rsw = RecordStore.openRecordStore("kjKData", false);
                    ba = rsw.getRecord(1);
                    if (null != ba) sbKakutei.append(new String(ba, "UTF-8"));
                    rsx = RecordStore.openRecordStore("kjCData", false);
                    ba = rsx.getRecord(1);
                    if (null != ba) tb.insert(new String(ba, "UTF-8"), 0);
        } catch (Exception e) {
                    e.printStackTrace();
                } finally {
                    try {
                        if (null != rsw) rsw.closeRecordStore();
            if (null != rsx) rsx.closeRecordStore();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
        }
    }

    private void storeData()
    {
        byte[] ba;
        int len;

        if (0 == bTextSave) {
            try {
                try {
                    RecordStore.deleteRecordStore("kjKData");
                    RecordStore.deleteRecordStore("kjCData");
                } catch (RecordStoreNotFoundException e) {
                }
                RecordStore rsw = RecordStore.openRecordStore("kjKData", true);
                if (sbKakutei.toString().length() > 500) {
                    ba = sbKakutei.toString().substring(0, 499).getBytes("UTF-8");
                } else {
                    ba = sbKakutei.toString().getBytes("UTF-8");
                }
                rsw.addRecord(ba, 0, len = ba.length);
                rsw.closeRecordStore();
                rsw = RecordStore.openRecordStore("kjCData", true);
                len = (1500 - len) / 3;
                if (1498 > len && len > 0) {
                    if (tb.getString().length() > len) {
                        ba = tb.getString().substring(0, (1500 - len) / 3).getBytes("UTF-8");
                    } else {
                        ba = tb.getString().getBytes("UTF-8");
                    }
                    rsw.addRecord(ba, 0, ba.length);
                    rsw.closeRecordStore();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    public class EditScreen extends Canvas
    {
        private int ifh, ifw, ifw2, ifw3, iX, iY, iCx, iCy, iIx, iIy, iKakuteiLen;
        private int iLeft, iRight, iUp, iDown;
        private int iLeftBt, iRightBt, iUpBt, iDownBt;   // BT Keyboard for SonyEricsson
        private char cMoji;
        private boolean bInit = true, bRepeat = false, bRepeatProcess = false;
           private byte[] bAr;
           private String sShiftIndicator = "", sTenKeyMode = "F";
           private int iRepeatedKey = 0, iRepeatedKeyCount = 0;

        public EditScreen()
        {
            switch (bKJFont) {
                case 0 :
                    font = Font.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,Font.SIZE_LARGE);
                    break;
                case 2 :
                    font = Font.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,Font.SIZE_SMALL);
                    break;
                default :
                    font = Font.getFont(Font.FACE_MONOSPACE,Font.STYLE_PLAIN,Font.SIZE_MEDIUM);
            }
            iWidth = getWidth();
            iHeight = getHeight();
            ifh = font.getHeight();
            ifw = font.charWidth('0');
            ifw2 = font.charWidth('_');
            ifw3 = font.charWidth('＿');
            bAr = new byte[1];
            if (bSonyEricsson || bE7_00 || bN97mini) {
                iLeft = -3;
                iRight = -4;
                iUp = -1;
                iDown = -2;
            } else {
                iLeft = getKeyCode(Canvas.LEFT);
                iRight = getKeyCode(Canvas.RIGHT);
                iUp = getKeyCode(Canvas.UP);
                iDown = getKeyCode(Canvas.DOWN);
            }
            iLeftBt = 0x0f807;
            iRightBt = 0x0f808;
            iUpBt = 0x0f809;
            iDownBt = 0x0f80a;
        }

    public void keyRepeated(int keyCode)
    {
            if (keyCode == iRepeatedKey) {
                ++iRepeatedKeyCount;
                if (iRepeatedKeyCount > 10 && !bRepeatProcess) {
                    bRepeatProcess = true;
                    if (bSonyEricssonKeyAssist && (-10 == keyCode || 0x0f84a == keyCode)) {
                        changeMode(false);
                        dispTb(3);
/*                } else if ('#' == keyCode) {
                        if (!bTenKeyMode) {
                            keyPressed(-8);
                        } else {
                            changeMode(false);
                        }
                        bTenKeyMode = !bTenKeyMode;
                        sTenKeyMode = (bTenKeyMode) ? "" : "F";
                        repaint();
                        return; */
                    }
                }
            }
            if ('#' != keyCode) {
        bRepeat = true;
        keyPressed(keyCode);
            }
            iRepeatedKey = keyCode;
    }

    public void keyReleased(int keyCode)
        {
            iRepeatedKeyCount = 0;
            bRepeatProcess = false;
            if (-50 == keyCode || 137 == keyCode) { // -50 = 0xce for shift on E61, 137 (0x89) for BB
                bShiftPressing = false;
            } else if (-53 == keyCode) {  // only valid for Asha 303?
                bCtrlPressing = false;
            } else if (-54 == keyCode) {  // only valid for Asha 303
                bSymPressing = false;
            }
        }

        public void keyPressedTen(int keyCode) // this is not implemented
    {
            if ('0' <= keyCode && keyCode <= '9') {
                switch (iMode) {
                    case 0 :    // Zenkaku Alphabet
                    case 1 :    // Hankaku Alphabet

                        break;
                    case 2 :    // Kanji
                    case 3 :    // Zenkaku Kana
                    case 4 :    // Hankaku Kana
            break;
                    case 5 :    // Zenkaku Num
                        zenkaku(keyCode);
                        break;
                    case 6 :    // Hankaku Num
                        bAr[0] = (byte) keyCode;
                        insKakutei(new String(bAr));
                        break;
                }
            } else if (8 == keyCode || -8 == keyCode) {
                if (0 <= iKakuteiPos) {
                    sbKakutei.deleteCharAt(iKakuteiPos);
                    iKakuteiPos--;
        }
            } else if ('#' == keyCode) {
        changeMode(true);
            } else if ('*' == keyCode) {
        if (++iKigouPanel > 1) iKigouPanel = 0;
                disp.setCurrent(sp);
            } else if (!bKJinProc && (keyCode == iLeft || keyCode == iLeftBt) && 0 == sbHiragana.length()) {
                if (iKakuteiPos >= 0) iKakuteiPos--;
            } else if (!bKJinProc && (keyCode == iRight || keyCode == iRightBt) && 0 == sbHiragana.length()) {
                if (iKakuteiPos < sbKakutei.length() - 1) iKakuteiPos++;
            } else if (!bKJinProc && (keyCode == iUp || keyCode == iUpBt || (bSonyEricsson && -38 == keyCode)) && 0 == sbHiragana.length()) {
                cursMove(true);
            } else if (!bKJinProc && (keyCode == iDown || keyCode == iDownBt || (bSonyEricsson && -39 == keyCode)) && 0 == sbHiragana.length()) {
                cursMove(false);
            } else if (bKJinProc && (keyCode == iLeft || keyCode == iLeftBt) && 0 < sbHiragana.length()) {
                if (iHiraStart < iHiraEnd) {
                    iHiraEnd--;
                } else {
                    iHiraEnd = sbHiragana.length() - 1;
                }
                bNeedSetWord = true;
                kjHenkan(true);
            } else if (bKJinProc && (keyCode == iRight || keyCode == iRightBt) && 0 < sbHiragana.length()) {
                if (iHiraEnd < sbHiragana.length() - 1) {
                    iHiraEnd++;
                } else {
                    iHiraEnd = iHiraStart;
                }
                bNeedSetWord = true;
                kjHenkan(true);
            }
        }

        public void keyPressed(int key)
        {
            int keyCode = key;
            int iTemp;

            /* Begin : key simulation test */
//            if (108 == keyCode) {
//                keyCode = -10;
//                bE61 = true;
//                bE61old = true;
//            }
            /* End : key simulation test */

            if (bTenKeyMode) {
                keyPressedTen(keyCode);
            } else {
                // Ctrl key handler for Asha 303
                if (bCtrlPressing) {
                    if (97 <= keyCode && keyCode <= 122) {
                        keyCode -= 96;
                    } else if (65 <= keyCode && keyCode <= 90) {
                        keyCode -= 64;
                    }
                }
                if (bSymPressing) {
                    switch (keyCode) {
                        case 84 :
                        case 116 : keyCode = iUp; break;
                        case 70 :
                        case 102 : keyCode = iLeft; break;
                        case 72 :
                        case 104 : keyCode = iRight; break;
                        case 66 :
                        case 98 : keyCode = iDown; break;
                        case 71:
                        case 103 : keyCode = -5; break;
                    }
                }

                bShift = false;
//                if ((1 != iShift && 8 == keyCode) || -8 == keyCode) {     // BackSpace -8 = 0xf8 for M600
                if ((!bShiftPressing && 1 != iShift && 8 == keyCode) || -8 == keyCode) {     // BackSpace -8 = 0xf8 for M600
                    if (bKJinProc) bListConvMode = bKJinProc = false;
                    else {
                        if (0 < sbRomaji.length()) {
                            sbRomaji.deleteCharAt(sbRomaji.length() - 1);
                            switch (sbHiragana.charAt(sbHiragana.length() - 1)) {
                                case 'ぁ' :
                                case 'ぃ' :
                                case 'ぅ' :
                                case 'ぇ' :
                                case 'ぉ' :
                                case 'ゃ' :
                                case 'ゅ' :
                                case 'ょ' : rbuff.deleteLast(true); break;
                                default : rbuff.deleteLast(false);
                            }
                        }
                        if (0 < sbHiragana.length()) {
                            sbHiragana.deleteCharAt(sbHiragana.length() - 1);
                            if (iHiraPos >= sbHiragana.length()) {
                                iHiraPos = sbHiragana.length() - 1;
                                if (iHiraPos >= 0) {
                                    switch (sbHiragana.charAt(iHiraPos)) {
                                        case 'b' :
                                        case 'B' :
                                        case 'd' :
                                        case 'D' :
                                        case 'f' :
                                        case 'F' :
                                        case 'l' :
                                        case 'L' :
                                        case 'g' :
                                        case 'G' :
                                        case 'j' :
                                        case 'J' :
                                        case 'k' :
                                        case 'K' :
                                        case 'p' :
                                        case 'P' :
                                        case 's' :
                                        case 'S' :
                                        case 't' :
                                        case 'T' :
                                        case 'n' :
                                        case 'N' :
                                        case 'h' :
                                        case 'H' :
                                        case 'm' :
                                        case 'M' :
                                        case 'y' :
                                        case 'Y' :
                                        case 'r' :
                                        case 'R' :
                                        case 'w' :
                                        case 'x' :
                                        case 'X' :
                                        case 'v' :
                                        case 'V' :
                                        case 'z' :
                                        case 'Z' : iHiraPos--; break;
                                        default :
                                    }
                                }
                            }
                            if (0 == sbHiragana.length()) {
                                sbRomaji.delete(0, sbRomaji.length());
                                rbuff.deleteAll();
                            }
                        } else if (0 <= iKakuteiPos) {
                            sbKakutei.deleteCharAt(iKakuteiPos);
                            iKakuteiPos--;
                        }
                    }
                    //bInputInhibit = false;
                } else if (-53 == keyCode) {
                    bCtrlPressing = true;
                } else if (-54 == keyCode) {
                    bSymPressing = true;
                } else if (-50 == keyCode || 137 == keyCode) { // -50 = 0xce for shift on E61, 137 (0x89) for BB
                    bShift = true;
                    bShiftPressing = true;
                    if (!bRepeat && -50 == keyCode) { // -50 = 0xce for shift on E61
                        iShift++;
                        if (2 < iShift) iShift = 0;
                    }
                    if (!bRepeat && bBB && 2 == iMode) bBLShift = !bBLShift;
                } else if (bE61 && 5 > iMode && -10 == keyCode) {    // Green key
                    if (!bRepeat) iE61NumLock++;
                    if (2 < iE61NumLock) iE61NumLock = 0;
                } else if (!bRepeat && (-11 == keyCode || (bSonyEricssonKeyAssist && (-10 == keyCode || 0x0f84a == keyCode)))) {    // F5 (-11) SonyEricsson back button below jog dial or M600i OK
                    changeMode(true);
                } else if (!bRepeat && keyCode == iInsKey) {
                    dispTb(1);
                } else if (!bRepeat && keyCode == iAddKey) {
                    dispTb(2);
                } else if (!bRepeat && keyCode == iCopyKey) {
                    dispTb(3);
                } else if (!bRepeat && keyCode == iModeKey) {
                    changeMode(true);
                } else if (!bRepeat && keyCode == iKJModeKey) {
                    iMode = 2;
                    if (bKJinProc) kjKakutei();
                    setSMode();
                } else if (!bRepeat && keyCode == iQuickLoadKey) {
                    quickFile(false);
                } else if (!bRepeat && keyCode == iQuickSaveKey) {
                    quickFile(true);
                } else if (!bKJinProc && ((!bBB && keyCode == iLeft) || keyCode == iLeftBt || (bBB && keyCode == iUp)) && 0 == sbHiragana.length()) {
                    if (iKakuteiPos >= 0) iKakuteiPos--;
                } else if (!bKJinProc && ((!bBB && keyCode == iRight) || keyCode == iRightBt || (bBB && keyCode == iDown)) && 0 == sbHiragana.length()) {
                    if (iKakuteiPos < sbKakutei.length() - 1) iKakuteiPos++;
                } else if (!bKJinProc && ((!bBB && keyCode == iUp) || keyCode == iUpBt || (bBB && keyCode == iLeft) || (bSonyEricsson && -38 == keyCode)) && 0 == sbHiragana.length()) {
                    cursMove(true);
                } else if (!bKJinProc && ((!bBB && keyCode == iDown) || keyCode == iDownBt || (bBB && keyCode == iRight) || (bSonyEricsson && -39 == keyCode)) && 0 == sbHiragana.length()) {
                    cursMove(false);
//                } else if (!bKJinProc && (keyCode == 127 || (iShift > 0 && 8 == keyCode)) && 0 == sbHiragana.length()) {
                } else if (!bKJinProc && (keyCode == 127 || ((bShiftPressing || 1 == iShift) && 8 == keyCode)) && 0 == sbHiragana.length()) {
                    if (sbKakutei.length() > iKakuteiPos + 1) sbKakutei.deleteCharAt(iKakuteiPos + 1);
                    if (1 == iShift) iShift = 0;
                    bBLShift = false;
                    bInputInhibit = false;
                } else if (bKJinProc && ((!bBB && keyCode == iLeft) || keyCode == iLeftBt || (bBB && keyCode == iUp)) && 0 < sbHiragana.length()) {
                    if (iHiraStart < iHiraEnd) {
                        iHiraEnd--;
                    } else {
                        iHiraEnd = sbHiragana.length() - 1;
                    }
                    bNeedSetWord = true;
                    kjHenkan(true);
                } else if (bKJinProc && ((!bBB && keyCode == iRight) || keyCode == iRightBt || (bBB && keyCode == iDown)) && 0 < sbHiragana.length()) {
                    if (iHiraEnd < sbHiragana.length() - 1) {
                        iHiraEnd++;
                    } else {
                        iHiraEnd = iHiraStart;
                    }
                    bNeedSetWord = true;
                    kjHenkan(true);
                } else {
                    if (12289 == keyCode) {  // UTF-16LE kutouten
                        keyCode = 0x2c;
                    } else if (12290 == keyCode) {  // UTF-16LE kutouten
                        keyCode = 0x2e;
                    } else if (65280 < keyCode && keyCode < 65375) { // UTF-16LE special charcters
                        keyCode -= 65248;
                    }

                    if (bE61) {
                        if (5 <= iMode || 0 < iE61NumLock) keyCode = e61key2(keyCode);
                        else if (bE61old) keyCode = e61key(keyCode);
                    } else if (bFreedom) {                        // should remove else?
                        keyCode = freedomMini(keyCode);
                    }
                    if ((!bE61 || 5 <= iMode) && !bSonyEricssonKeyAssist && -10 == keyCode) keyCode = 0x2d; // Phone start key -> '-' to enter ー
                    if (0 < iE61NumLock && 0x20 == keyCode) {
                        bE61Num2dConv = true;
                        keyCode = 0x2d;        // '-' in NumLock
                    } else bE61Num2dConv = false;

                    if (iMode < 3) {
                        if (0x41 <= keyCode) {
                            if (keyCode <= 0x5a) {
                                if (bStrictShiftMode && 0 == iShift) keyCode |= 0x20;
                            } else if (0x61 <= keyCode && keyCode <= 0x7a) {
                                if (iShift > 0 && iShift < 3) keyCode &= 0xdf;
                            }
                        }

//                        if (0x61 <= keyCode && keyCode <= 0x7a && iShift > 0 && iShift < 3) keyCode &= 0xdf;
//                        else if (bStrictShiftMode && 0x41 <= keyCode && keyCode <= 0x5a && 0 == iShift) keyCode |= 0x20;
                    }

                    if (0x0a == keyCode || 0x0d == keyCode || -5 == keyCode || -42 == keyCode || ((bN97mini || bE7_00) && 64 == keyCode)) { // Freedom mini and M600i 0x0d, -5(fd) (only E61?), -42(d6) for P990i
                        if (2 <= iMode && iMode <= 4) {
                            if (bKJinProc) kjKakutei();
                            else {
                                if (0 == sbHiragana.length()) sbKakutei.insert(iKakuteiPos + 1, cParaSepa);
                                else {
                                    sbKakutei.insert(iKakuteiPos + 1, sbHiragana.toString());
                                    iTemp = sbHiragana.length();
                                    iKakuteiPos += iTemp - 1;
                                    sbHiragana.delete(0, iTemp);
                                    iHiraPos = -1;
                                    sbRomaji.delete(0, sbRomaji.length());
                                    rbuff.deleteAll();
                                }
                                iKakuteiPos++;
                            }
                        } else {
                            sbKakutei.insert(iKakuteiPos + 1, cParaSepa);
                            iKakuteiPos++;
                        }
                    } else if (null != sp && (iSpChr == keyCode || 0x2f == keyCode) && iMode < 5) {
                        if (++iKigouPanel > 1) iKigouPanel = 0;
                        disp.setCurrent(sp);
    //                   } else if (0x20 <= keyCode && keyCode < 0x7f) {
                    } else if (0x20 <= keyCode && keyCode <= 0x0ff) {
                        if (1 < iMode && iMode < 5) {
                            if (2 == iMode && 0x20 == keyCode) {
                                if (0 < sbHiragana.length()) {
                                    kjHenkan(1 != iShift);
                                } else {
                                    if ((!bBB && (1 != iShift && !bShiftPressing)) || (bBB && !bBLShift)) sbKakutei.insert(iKakuteiPos + 1, " ");
                                    else sbKakutei.insert(iKakuteiPos + 1, "　");
                                    iKakuteiPos++;
                                }
                            } else {
                                if (bKJinProc) kjKakutei();
                                romajiConv(keyCode);
                            }
                        } else if (0 == iMode || 5 == iMode) {
                            zenkaku(keyCode);
                        } else {
                            bAr[0] = (byte) keyCode;
                            insKakutei(new String(bAr));
                        }
                    } else if (2 == iMode && (iUp == keyCode || iUpBt == keyCode || (bSonyEricsson && -38 == keyCode))) kjHenkan(false);    // -38 P990i Jog Up
                    else if (2 == iMode && (iDown == keyCode || iDownBt == keyCode || (bSonyEricsson && -39 == keyCode))) kjHenkan(true);        // -39 P990i Hig Down

                    if (1 == iShift) iShift = 0;
                    if (1 == iE61NumLock) iE61NumLock = 0;
                    bBLShift = false;
                }
            }
            bRepeat = false;
            repaint();
        }

        public void insKakutei(String r)
        {
            int iTemp;

            sbKakutei.insert(iKakuteiPos + 1, sbHiragana.toString() + r);
            iTemp = sbHiragana.length();
            iKakuteiPos += iTemp + 1;
            iHiraPos = -1;
            sbHiragana.delete(0, iTemp);
        }

        public void kjKakutei()
        {
            sbHiragana.delete(iHiraStart, iHiraEnd + 1);
            sbHiragana.insert(iHiraStart, sKJKouho);
            iHiraStart += sKJKouho.length();
            iHiraEnd = sbHiragana.length() - 1;
            //js.kakutei();
            sKJKouho = sbHiragana.toString().substring(iHiraStart, iHiraEnd + 1);
            if (iHiraStart > iHiraEnd) {
                sbKakutei.insert(iKakuteiPos + 1, sbHiragana);
                iKakuteiPos += sbHiragana.length();
                if (bCombConvMode) js.kakutei(sHiraganaYomi, sbHiragana.toString());
                else if (bListConvMode) js.kakutei(iListConvPos);
                else js.kakutei();
                sbHiragana.delete(0, sbHiragana.length());
                iHiraPos = -1;
                sbRomaji.delete(0, sbRomaji.length());
                rbuff.deleteAll();
                bListConvMode = bKJinProc = false;
            } else {
                bNeedSetWord = true;
                bListConvMode = false;
            }
        }

        public void kjHenkan(boolean next)
        {
            if (0 < sbHiragana.length()) {
                if (!bKJinProc) {
                    if ((sbHiragana.charAt(sbHiragana.length() - 1) | 0x20) == 'n') {
                        sbHiragana.deleteCharAt(sbHiragana.length() - 1);
                        sbHiragana.append("ん");
                    }
                    sHiraganaYomi = sbHiragana.toString();
                    iHiraStart = 0;
                    iHiraEnd = sbHiragana.length() - 1;
                    bNeedSetWord = true;
                    bKJinProc = true;
                }
                if (bNeedSetWord) {
                    if (0 == iHiraStart && iHiraEnd == sbHiragana.length() - 1) {
                        js.setWord(sbHiragana.toString(), rbuff.toString()); //sbRomaji.toString()
                        bCombConvMode = false;
                    } else {
                        js.setWord(sbHiragana.toString().substring(iHiraStart, iHiraEnd + 1), "");
                        bCombConvMode = true;
                    }
                    iConvCount = 0;
                    bListConvMode = bNeedSetWord = false;
                }
                if (next) {
                    if (bListConvMode) {
                        iListConvPos++;
                        if (iListConvPos >= saListConv.length) iListConvPos = 0;
                    } else {
                        sKJKouho = js.getNext();
                        iConvCount++;
                        if (0 != bListConv && iConvCount >= bListConv) {
                            bListConvMode = true;
                            iListConvPos = js.getCurrentSeq();
                            saListConv = new String[js.getAll()];
                            saListConv[0] = js.getFirst();
                            for (int i = 1; i < saListConv.length; i++) {
                                saListConv[i] = js.getNext();
                            }
                            iListConvSt = iListConvPos - 1;
                            if (iListConvSt < 0) iListConvSt = 0;
//                            iListConvSt = (iListConvPos < saListConv.length - 1) ? iListConvPos - 1 : iListConvPos - 2;
                        }
                    }
                } else {
                    if (bListConvMode) {
                        iListConvPos--;
                        if (iListConvPos < 0) iListConvPos = saListConv.length - 1;
                    } else {
                        sKJKouho = js.getPrev();
                    }
                }
                if (bListConvMode) sKJKouho = saListConv[iListConvPos];
            }
        }

        public int e61key2(int keyCode)
        {
            int newKeyCode = keyCode;

            if (null != baE61spe) {
                switch (keyCode) {
                    case 0x71 : newKeyCode = baE61spe[0]; break; // q
                    case 0x77 : newKeyCode = baE61spe[1]; break; // w
                    case 0x65 : newKeyCode = baE61spe[2]; break; // e
                    case 0x72 : newKeyCode = baE61spe[3]; break; // r
                    case 0x74 : newKeyCode = baE61spe[4]; break; // t
                    case 0x79 : newKeyCode = baE61spe[5]; break; // y
                    case 0x75 : newKeyCode = baE61spe[6]; break; // u
                    case 0x69 : newKeyCode = baE61spe[7]; break; // i
                    case 0x6f : newKeyCode = baE61spe[8]; break; // o
                    case 0x70 : newKeyCode = baE61spe[9]; break; // p
                    case 0x61 : newKeyCode = baE61spe[10]; break; // a
                    case 0x73 : newKeyCode = baE61spe[11]; break; // s
                    case 0x64 : newKeyCode = baE61spe[12]; break; // d
                    case 0x66 : newKeyCode = baE61spe[13]; break; // f
                    case 0x67 : newKeyCode = baE61spe[14]; break; // g
                    case 0x68 : newKeyCode = baE61spe[15]; break; // h
                    case 0x6a : newKeyCode = baE61spe[16]; break; // j
                    case 0x6b : newKeyCode = baE61spe[17]; break; // k
                    case 0x6c : newKeyCode = baE61spe[18]; break; // l
                    case 0x7a : newKeyCode = baE61spe[19]; break; // z
                    case 0x78 : newKeyCode = baE61spe[20]; break; // x
                    case 0x63 : newKeyCode = baE61spe[21]; break; // c
                    case 0x76 : newKeyCode = baE61spe[22]; break; // v
                    case 0x62 : newKeyCode = baE61spe[23]; break; // b
                    case 0x6e : newKeyCode = baE61spe[24]; break; // n
                    case 0x6d : newKeyCode = baE61spe[25]; break; // m
                }
            }
            return newKeyCode;
           }

/*        public int e61key2xx(int keyCode)
        {
            int newKeyCode = keyCode;

               switch (keyCode) {
                   case 0x71 : newKeyCode = 0x21; break; // !
                   case 0x61 : newKeyCode = 0x22; break; // "
                   case 0x7a : newKeyCode = 0x27; break; // '
                   case 0x77 : newKeyCode = 0x26; break; // &
                   case 0x73 : newKeyCode = 0x40; break; // @
                   case 0x78 : newKeyCode = 0x28; break; // (
                   case 0x65 : newKeyCode = 0x2d; break; // -
                   case 0x64 : newKeyCode = 0x2b; break; // +
                   case 0x63 : newKeyCode = 0x29; break; // )
                   case 0x69 : newKeyCode = 0x2f; break; // /
                   case 0x6b : newKeyCode = 0x24; break; // $
                   case 0x3b : newKeyCode = 0x23; break; // #
                   case 0x6f : newKeyCode = 0x3d; break; // =
                   case 0x6c : newKeyCode = 0x25; break; // %
                   case 0x27 : newKeyCode = 0x5f; break; // _
                   case 0x70 : newKeyCode = 0x3f; break; // ?
                   // for new E61 code
                   case 0x72 : newKeyCode = 0x31; break; // 1
                   case 0x74 : newKeyCode = 0x32; break; // 2
                   case 0x79 : newKeyCode = 0x33; break; // 3
                   case 0x66 : newKeyCode = 0x34; break; // 4
                   case 0x67 : newKeyCode = 0x35; break; // 5
                   case 0x68 : newKeyCode = 0x36; break; // 6
                   case 0x76 : newKeyCode = 0x37; break; // 7
                   case 0x62 : newKeyCode = 0x38; break; // 8
                   case 0x6e : newKeyCode = 0x39; break; // 9
                   case 0x6d : newKeyCode = 0x30; break; // 0
                   case 0x75 : newKeyCode = 0x2a; break; // *
                   case 0x6a : newKeyCode = 0x23; break; // #
                   default:
               }
            return newKeyCode;
        }*/

        public int e61key(int keyCode)
        {
            int newKeyCode = keyCode;

            if (0 <= iMode && iMode <= 4) {
                switch (keyCode) {
                    case 0x31 : newKeyCode = 0x72; break;
                    case 0x32 : newKeyCode = 0x74; break;
                    case 0x33 : newKeyCode = 0x79; break;
                    case 0x34 : newKeyCode = 0x66; break;
                    case 0x35 : newKeyCode = 0x67; break;
                    case 0x36 : newKeyCode = 0x68; break;
                    case 0x37 : newKeyCode = 0x76; break;
                    case 0x38 : newKeyCode = 0x62; break;
                    case 0x39 : newKeyCode = 0x6e; break;
                    case 0x30 : newKeyCode = 0x6d; break;
                    case 0x2a : newKeyCode = 0x75; break;
                    case 0x23 : newKeyCode = 0x6a; break;
                    case 0x20ac : newKeyCode = 0x47; break;
                    default:
                }
            }
            return newKeyCode;
        }

        public int freedomMini(int keyCode)
        {
            int newKeyCode = keyCode;

            switch (keyCode) {
                case 0x22 : newKeyCode = 0x40; break;    // @
                case 0xa3 : newKeyCode = 0x23; break;    // #
                case 0x23 : newKeyCode = 0x5c; break;    // \
                case 0x40 : newKeyCode = 0x22; break;     // "
                case 0xe9 : newKeyCode = 0x24; break;   // $
                default:
            }
            return newKeyCode;
        }

        public String zenkaku2(int keyCode)
        {
            bAr[0] = (byte) keyCode;
            String r;

            if (0 == iMode || 3 == iMode || 5 == iMode) {
                switch (keyCode) {
                    case 0x21 : r = "！"; break;
                    case 0x22 : r = "”"; break;
                    case 0x23 : r = "＃"; break;
                    case 0x24 : r = "＄"; break;
                    case 0x25 : r = "％"; break;
                    case 0x26 : r = "＆"; break;
                    case 0x27 : r = "’"; break;
                    case 0x28 : r = "（"; break;
                    case 0x29 : r = "）"; break;
                    case 0x2a : r = "＊"; break;
                    case 0x2b : r = "＋"; break;
                    case 0x2c : r = "，"; break;
                    case 0x2d : r = "－"; break;
                    case 0x2e : r = "．"; break;
                    case 0x2f : r = "／"; break;
                    case 0x30 : r = "０"; break;
                    case 0x31 : r = "１"; break;
                    case 0x32 : r = "２"; break;
                    case 0x33 : r = "３"; break;
                    case 0x34 : r = "４"; break;
                    case 0x35 : r = "５"; break;
                    case 0x36 : r = "６"; break;
                    case 0x37 : r = "７"; break;
                    case 0x38 : r = "８"; break;
                    case 0x39 : r = "９"; break;
                    case 0x3a : r = "："; break;
                    case 0x3b : r = "；"; break;
                    case 0x3c : r = "＜"; break;
                    case 0x3d : r = "＝"; break;
                    case 0x3e : r = "＞"; break;
                    case 0x3f : r = "？"; break;
                    case 0x40 : r = "＠"; break;
                    case 0x5b : r = "［"; break;
                    case 0x5c : r = "￥"; break;
                    case 0x5d : r = "］"; break;
                    case 0x5e : r = "＾"; break;
                    case 0x5f : r = "＿"; break;
                    case 0x60 : r = "‘"; break;
                    case 0x7b : r = "｛"; break;
                    case 0x7c : r = "｜"; break;
                    case 0x7d : r = "｝"; break;
                    case 0x7e : r = "～"; break;
                    default: r = new String(bAr);
                }
            } else r = new String(bAr);
            return r;
        }

        public void zenkaku(int keyCode)
        {
            String r;
            switch (keyCode) {
                case 0x20 : r = (bShiftPressing || 1 == iShift) ? "　" : " "; break;
                case 0x41 : r = "Ａ"; break;
                case 0x42 : r = "Ｂ"; break;
                case 0x43 : r = "Ｃ"; break;
                case 0x44 : r = "Ｄ"; break;
                case 0x45 : r = "Ｅ"; break;
                case 0x46 : r = "Ｆ"; break;
                case 0x47 : r = "Ｇ"; break;
                case 0x48 : r = "Ｈ"; break;
                case 0x49 : r = "Ｉ"; break;
                case 0x4a : r = "Ｊ"; break;
                case 0x4b : r = "Ｋ"; break;
                case 0x4c : r = "Ｌ"; break;
                case 0x4d : r = "Ｍ"; break;
                case 0x4e : r = "Ｎ"; break;
                case 0x4f : r = "Ｏ"; break;
                case 0x50 : r = "Ｐ"; break;
                case 0x51 : r = "Ｑ"; break;
                case 0x52 : r = "Ｒ"; break;
                case 0x53 : r = "Ｓ"; break;
                case 0x54 : r = "Ｔ"; break;
                case 0x55 : r = "Ｕ"; break;
                case 0x56 : r = "Ｖ"; break;
                case 0x57 : r = "Ｗ"; break;
                case 0x58 : r = "Ｘ"; break;
                case 0x59 : r = "Ｙ"; break;
                case 0x5a : r = "Ｚ"; break;
                case 0x61 : r = "ａ"; break;
                case 0x62 : r = "ｂ"; break;
                case 0x63 : r = "ｃ"; break;
                case 0x64 : r = "ｄ"; break;
                case 0x65 : r = "ｅ"; break;
                case 0x66 : r = "ｆ"; break;
                case 0x67 : r = "ｇ"; break;
                case 0x68 : r = "ｈ"; break;
                case 0x69 : r = "ｉ"; break;
                case 0x6a : r = "ｊ"; break;
                case 0x6b : r = "ｋ"; break;
                case 0x6c : r = "ｌ"; break;
                case 0x6d : r = "ｍ"; break;
                case 0x6e : r = "ｎ"; break;
                case 0x6f : r = "ｏ"; break;
                case 0x70 : r = "ｐ"; break;
                case 0x71 : r = "ｑ"; break;
                case 0x72 : r = "ｒ"; break;
                case 0x73 : r = "ｓ"; break;
                case 0x74 : r = "ｔ"; break;
                case 0x75 : r = "ｕ"; break;
                case 0x76 : r = "ｖ"; break;
                case 0x77 : r = "ｗ"; break;
                case 0x78 : r = "ｘ"; break;
                case 0x79 : r = "ｙ"; break;
                case 0x7a : r = "ｚ"; break;
                default: r = zenkaku2(keyCode);
            }
            insKakutei(r);
        }

        public void romajiConv(int keyCode)
        {
            boolean bNewChar = true;
            bAr[0] = (byte) keyCode;
            int key2 = keyCode | 0x20;
            int iTemp;
            String result;
            String sNewChar = new String(bAr);
            sbRomaji.append(sNewChar);
            rbuff.append(sNewChar);
            String sMikakutei = sbHiragana.toString().substring(iHiraPos + 1);

            if (0x61 == key2 || 0x69 == key2 || 0x75 == key2 || 0x65 == key2 || 0x6f == key2) {
                if (bBB && bBLShift && 0x75 == key2) {
                    if (4 == iMode) sbHiragana.append("ｰ");
                    else sbHiragana.append("ー");
                    iHiraPos = sbHiragana.length() - 1;
                } else {
                    result = rconv.getMoji(iMode - 2, sMikakutei + sNewChar);
                    sbHiragana.delete(iHiraPos + 1, sbHiragana.length());
                    sbHiragana.append(result);
                    iHiraPos = sbHiragana.length() - 1;
                }
            } else if (0x20 == keyCode) {
                if (4 == iMode || (!bShiftPressing && 1 != iShift)) sbHiragana.append(" ");
                else sbHiragana.append("　");
                iHiraPos = sbHiragana.length() - 1;
            } else if (0x2c == keyCode && !bBB) {
                if (4 == iMode) sbHiragana.append("､");
                else sbHiragana.append("、");
                iHiraPos = sbHiragana.length() - 1;
            } else if (0x2d == keyCode && !bBB && (0 == iE61NumLock || (bE61Num2dConv && 0 < iE61NumLock))) {
                if (4 == iMode) sbHiragana.append("ｰ");
                else sbHiragana.append("ー");
                iHiraPos = sbHiragana.length() - 1;
            } else if (0x2e == keyCode && !bBB) {
                if (4 == iMode) sbHiragana.append("｡");
                else sbHiragana.append("。");
                iHiraPos = sbHiragana.length() - 1;
            } else if (0x5b == keyCode && !bBB) {
                if (4 == iMode) sbHiragana.append("｢");
                else sbHiragana.append("「");
                iHiraPos = sbHiragana.length() - 1;
            } else if (0x5d == keyCode && !bBB) {
                if (4 == iMode) sbHiragana.append("｣");
                else sbHiragana.append("」");
                iHiraPos = sbHiragana.length() - 1;
            } else if (0x3c == keyCode && bE61old) {
                if (4 == iMode) sbHiragana.append("<");
                else sbHiragana.append("「");
                iHiraPos = sbHiragana.length() - 1;
            } else if (0x3e == keyCode && bE61old) {
                if (4 == iMode) sbHiragana.append(">");
                else sbHiragana.append("」");
                iHiraPos = sbHiragana.length() - 1;
            } else if (0x6d == keyCode && bBB && bBLShift) {
                if (4 == iMode) sbHiragana.append("｡");
                else sbHiragana.append("。");
                iHiraPos = sbHiragana.length() - 1;
            } else if (0x6e == keyCode && bBB && bBLShift) {
                if (4 == iMode) sbHiragana.append("､");
                else sbHiragana.append("、");
                iHiraPos = sbHiragana.length() - 1;
            } else if (0x74 == keyCode && bBB && bBLShift) {
                if (4 == iMode) sbHiragana.append("｢");
                else sbHiragana.append("「");
                iHiraPos = sbHiragana.length() - 1;
            } else if (0x79 == keyCode && bBB && bBLShift) {
                if (4 == iMode) sbHiragana.append("｣");
                else sbHiragana.append("」");
                iHiraPos = sbHiragana.length() - 1;
            } else if (231 == keyCode && (bE61 && !bE61old)) {
                if (4 == iMode) sbHiragana.append("｢");
                else sbHiragana.append("「");
                iHiraPos = sbHiragana.length() - 1;
            } else if (61441 == keyCode && (bE61 && !bE61old)) {
                if (4 == iMode) sbHiragana.append("｣");
                else sbHiragana.append("」");
                iHiraPos = sbHiragana.length() - 1;
            } else {
                sNewChar = zenkaku2(keyCode);
                if (0 < sMikakutei.length()) {
                    if (0x79 != (key2) && sMikakutei.substring(sMikakutei.length() - 1).toLowerCase().equals("n")) {
                        sbHiragana.deleteCharAt(sbHiragana.length() - 1);
                        if (4 == iMode) sbHiragana.append("ﾝ");
                        else if (3 == iMode) sbHiragana.append("ン");
                        else sbHiragana.append("ん");
                        iHiraPos = sbHiragana.length() - 1;
                        if (0x6e != key2) sbHiragana.append(sNewChar);
                    } else if (0 == sNewChar.compareTo(sMikakutei.substring(sMikakutei.length() - 1))) {
                        sbHiragana.deleteCharAt(sbHiragana.length() - 1);
                        if (4 == iMode) sbHiragana.append("ｯ" + sNewChar);
                        else if (3 == iMode) sbHiragana.append("ッ" + sNewChar);
                        else sbHiragana.append("っ" + sNewChar);
                        iHiraPos = sbHiragana.length() - 2;
                    } else {
                        sbHiragana.append(sNewChar);
                        bNewChar = false;
                    }
                } else {
                    sbHiragana.append(sNewChar);
                    bNewChar = false;
                    if (0x61 > key2 || key2 > 0x7a) iHiraPos = sbHiragana.length() - 1;
                }
            }
            if (bNewChar) {
                sbRomaji.append(' ');
                rbuff.append(' ');
            }
            if (2 != iMode) {
                if (iHiraPos == sbHiragana.length() - 1) {
                    sbKakutei.insert(iKakuteiPos + 1, sbHiragana.toString());
                    iTemp = sbHiragana.length();
                    iKakuteiPos += iTemp;
                    sbHiragana.delete(0, iTemp);
                    iHiraPos = -1;
                    sbRomaji.delete(0, sbRomaji.length());
                    rbuff.deleteAll();
                }
            }
            bBLShift = false;
        }

        protected void cursMove(boolean up)        // !up = down
        {
            boolean bFlg, bFlg2, bFlg3;
            int i;
            int iPos, iPos2;
            bFlg = bFlg2 = bFlg3 = false;
            iPos = iPos2 = 0;
            iCx = 0;
            int initialKakuteiPos = iKakuteiPos;

            if (up && 0 > iKakuteiPos && 0 == iScreenPos) return;
            i = (up) ? 0 : iScreenPos;
            iKakuteiLen = sbKakutei.length();
            iX = iMargin;
            while (i <= iKakuteiLen) {
                if (i == iKakuteiPos + 1) {
                    iCx = iX;
                    if (up) {
                        i = (iX == iMargin) ? iPos - 1 : iPos;
                        if (0 > i) i = 0;
                           //iKakuteiPos = iPos ;
                        iX = iMargin;
                        bFlg2 = true;
                    }
                    bFlg = true;
                }
                if (i >= iKakuteiLen) {
                    if (bFlg2) iKakuteiPos = i - 1;
                    break;
                }
                cMoji = sbKakutei.charAt(i);
                if (cParaSepa == cMoji) {
                    System.out.print("if cParaSepa== ");
                    iX = iMargin;
                    bFlg3 = bFlg2;
                    bFlg2 = bFlg;
                    iPos = iPos2;
                    iPos2 = i + 1;
                } else {
                    ifw = font.charWidth(cMoji);
                    if (iWidth < iX + ifw + iMargin) {
                        System.out.print("if iWidth ");
                        iX = iMargin;
                        bFlg3 = bFlg2;
                        bFlg2 = bFlg;
                        iPos = iPos2;
                        iPos2 = i;
                    }
                    iX += ifw;
                }
                if (bFlg2) {
                    if (iCx <= iX) {
                        iKakuteiPos = i;
                        break;
                    } else if (bFlg3) {
                        iKakuteiPos = i - 1;
                        break;
                    }
                }
                i++;
            }

            if (initialKakuteiPos == iKakuteiPos) {
                iKakuteiPos = (up) ? -1 : iKakuteiLen - 1; // goto top or bottom
            }
        }

        public void setScreenPos()
        {
            int i;
            iX = iMargin;

            if (iScreenPos > iKakuteiPos) {
                i = iScreenPos = 0;
                while (true) {
                    if (iKakuteiLen <= i) break;
                    if (iKakuteiPos < i) break;
                    cMoji = sbKakutei.charAt(i);
                    if (cParaSepa == cMoji) {
                        iScreenPos = i + 1;
                        iX = iMargin;
                    } else {
                        ifw = font.charWidth(cMoji);
                        if (iWidth < iX + ifw + iMargin) {
                            iScreenPos = i;
                            iX = iMargin;
                        }
                        iX += ifw;
                    }
                    i++;
                }
            } else {
                boolean bFlg = true;
                int iPos;
                   iY = ifh;
                i = iPos = iScreenPos;
                while (true) {
                    if (iKakuteiLen <= i) break;
                    if (iKakuteiPos < i) break;
                    cMoji = sbKakutei.charAt(i);
                    if (cParaSepa == cMoji) {
                        iX = iMargin;
                        if (bFlg) {
                            bFlg = false;
                            iPos = i + 1;
                        }
                        iY += ifh;
                        if (iHeight < iY + ifh) {
                            i = iScreenPos = iPos;
                            iY = ifh;
                            bFlg = true;
                            continue;
                        }
                    } else {
                        ifw = font.charWidth(cMoji);
                        if (iWidth < iX + ifw + iMargin) {
                            iX = iMargin;
                            if (bFlg) {
                                bFlg = false;
                                iPos = i;
                            }
                            iY += ifh;
                            if (iHeight < iY + ifh) {
                                i = iScreenPos = iPos;
                                iY = ifh;
                                bFlg = true;
                                continue;
                            }
                        }
                        iX += ifw;
                    }
                    i++;
                }
            }
        }

        public void paint(Graphics g)
        {
            boolean bRepaint = false;
            iWidth = getWidth();
            iHeight = getHeight();
            iKakuteiLen = sbKakutei.length();
            setScreenPos();
            g.setFont(font);
            g.setColor(iBGColor);        // NAVY
            g.fillRect(0, 0, iWidth, iHeight);
//            g.setColor(0x00000080);        // NAVY
//               g.fillRect(0, 0, iWidth, ifh);
            g.setColor(iFontColor);
            if (iScreenPos > 0) g.fillRect(iMargin, ifh - 1, iWidth - iMargin - iMargin, 1);
            g.setColor(iTitleColor);        // YELLOW
            g.drawString("漢字入力画面 " + iKakuteiLen, iMargin, 0, Graphics.LEFT | Graphics.TOP);
            g.drawString(sMode + sTenKeyMode, iWidth - font.stringWidth(sMode + sTenKeyMode) - iMargin, 0, Graphics.LEFT | Graphics.TOP);
            sShiftIndicator = "";
            if (bBB && 2 == iMode && bBLShift) {
                sShiftIndicator = "LeftShift";
            } else {
                if (1 == iShift && 0 == iE61NumLock) sShiftIndicator = "shift";
                else if (2 == iShift && 0 == iE61NumLock) sShiftIndicator = "CAPS";
                else if (1 == iE61NumLock) sShiftIndicator = "Num";
                else if (2 == iE61NumLock) sShiftIndicator = "NumLk";
            }
            g.drawString(sShiftIndicator, iWidth - font.stringWidth(sShiftIndicator + " " + sMode + sTenKeyMode) - iMargin, 0, Graphics.LEFT | Graphics.TOP);

            g.setColor(iFontColor);        // WHITE
            iIx = iCx = iX = iMargin;
            iIy = iCy = iY = ifh;
            int i = iScreenPos, iSaveScreenPos = 0;
            bInputInhibit = false;
            while (true) {
                if (i == iKakuteiPos + 1) {
                    iIx = iX;
                    iIy = iY;
                }
                if (iKakuteiLen <= i) break;
                cMoji = sbKakutei.charAt(i);
                if (cParaSepa == cMoji) {
                    iX = iMargin;
                    iY += ifh;
                    if (0 == iSaveScreenPos) iSaveScreenPos = i + 1;
                    if (iHeight < iY + ifh) {
                        bInputInhibit = true;
                        break;
                    }
                } else {
                    ifw = font.charWidth(cMoji);
                    if (iWidth < iX + ifw + iMargin) {
                        iX = iMargin;
                        iY += ifh;
                        if (0 == iSaveScreenPos) iSaveScreenPos = i;
                        if (iHeight < iY + ifh) {
                            bInputInhibit = true;
                            break;
                        }
                    }
                    g.setColor(iBGColor);
                    g.fillRect(iX, iY, ifw, ifh);
                    g.setColor(iFontColor);
                    g.drawChar(cMoji, iX, iY, Graphics.LEFT | Graphics.TOP);
                    iX += ifw;
                }
                if (i == iKakuteiPos) {
                    iCx = iX;
                    iCy = iY;
                }
                i++;
            }
            //if (!(0 <= iKakuteiPos && iCx == iMargin && iCy == ifh)) g.fillRect(iCx, iCy, 2, ifh);
            g.fillRect(iCx, iCy, 2, ifh);
            i = 0;
            int j = 0;
            int iKouhoLen = sKJKouho.length(), iHiraLen = sbHiragana.length();
            boolean bUL;
            iX = iIx;
            iY = iIy;
            boolean bSetXY = true;
            while (true) {
                bUL = false;
                   if (bKJinProc) {
                    if (i < iHiraStart || j >= iKouhoLen) {
                        if (i >= iHiraLen) break;
                        cMoji = sbHiragana.charAt(i);
                        i++;
                    } else {
                        cMoji =  sKJKouho.charAt(j);
                        bUL = true;
                        if (0 == j) bSetXY = true;
                        j++;
                        if (j >= iKouhoLen) i = iHiraEnd + 1;
                    }
                } else if (!bKJinProc && i < iHiraLen) {
                       //if (iHiraStart <= i && i <= iHiraEnd) bUL = true;
                    cMoji = sbHiragana.charAt(i);
                    i++;
                } else {
                    break;
                   }
                ifw = font.charWidth(cMoji);
                if (iWidth < iX + ifw + iMargin) {
                    iX = iMargin;
                    iY += ifh;
                    if (iHeight < iY + ifh) {
                        //bInputInhibit = true;trun
                        iScreenPos = iSaveScreenPos;
                        bRepaint = true;
                        break;
                    }
                }
                if (bSetXY) {
                    iIx = iX;
                    iIy = iY;
                    bSetXY = false;
                }
                g.setColor(iFontColor);        // WHITE
                g.fillRect(iX, iY, ifw, ifh);
                g.setColor(iBGColor);        // NAVY
                g.drawChar(cMoji, iX, iY, Graphics.LEFT | Graphics.TOP);
                if (bUL) g.fillRect(iX, iY + ifh - 2 , ifw, 2);
                iX += ifw;
            }
            if (bListConvMode) {
                int iY3 = (iIy < iHeight / 2) ? iHeight - iIy - ifh : iIy;
                iListConvHeight = (iY3 - 7) / ifh;
                if (iListConvHeight > 5) iListConvHeight = 5;
                int iY2 = (iIy < (iHeight / 2)) ? iIy + ifh + 1: iIy - ifh * iListConvHeight - 8;
                if (iListConvSt > iListConvPos) iListConvSt = iListConvPos;
                else if (iListConvSt + iListConvHeight <= iListConvPos) iListConvSt = iListConvPos - iListConvHeight + 1;
                iListConvMax = 0;
                for (i = 0; i < iListConvHeight; i++) {
                    iY = i + iListConvSt;
                    if (iY < saListConv.length) {
                        if (iListConvMax < font.stringWidth(saListConv[iY])) iListConvMax = font.stringWidth(saListConv[iY]);
                    }
                }
                int iX2 = (iWidth - iListConvMax -iMargin - 10 < iIx) ? iWidth - iListConvMax - iMargin - 10: iIx;
                g.setColor(0x00C0C0C0);
                g.fillRect(iX2, iY2, iListConvMax + 10, ifh * iListConvHeight + 6);
                g.setColor(0x00FFFFFF);
                g.fillRect(iX2 + 1, iY2 + 1, iListConvMax + 8, ifh * iListConvHeight + 4);
                g.setColor(0x00696969);
                g.drawLine(iX2 + iListConvMax + 8, iY2 + 1, iX2 + iListConvMax + 8, iY2 + ifh * iListConvHeight + 4);
                g.drawLine(iX2 + 1, iY2 + ifh * iListConvHeight + 4, iX2 + iListConvMax + 8, iY2 + ifh * iListConvHeight + 4);
                g.setColor(0x00F0F8FF);
                g.fillRect(iX2 + 2, iY2 + 2, iListConvMax + 6, ifh * iListConvHeight + 2);
                g.setColor(0x00000000);
                g.drawLine(iX2 + iListConvMax + 9, iY2, iX2 + iListConvMax + 9, iY2 + ifh * iListConvHeight + 5);
                g.drawLine(iX2, iY2 + ifh * iListConvHeight + 5, iX2 + iListConvMax + 9, iY2 + ifh * iListConvHeight + 5);
                // Scroll bar
                g.setColor(0x00696969);
                g.drawLine(iX2 + iListConvMax + 5, iY2 + 2, iX2 + iListConvMax + 5, iY2 + ifh * iListConvHeight + 2);
                g.drawRect(iX2 + iListConvMax + 4,
                    iY2 + 2 + ifh * iListConvHeight * iListConvSt / saListConv.length,
                    2,
                    ifh * iListConvHeight * iListConvHeight / saListConv.length);
//                g.setColor(0x00FFFFFF);
//                g.fillRect(iX2 + 3, iY2 + 3, iListConvMax, ifh * iListConvHeight);
                for (i = 0; i < iListConvHeight; i++) {
                    iY = i + iListConvSt;
                    if (iY < saListConv.length) {
                        if (iY == iListConvPos) {
                            g.setColor(0x00000000);
                            g.fillRect(iX2 + 3, iY2 + (i * ifh) + 3, iListConvMax, ifh);
                            g.setColor(0x00FFFFFF);
                        } else {
                            g.setColor(0x00000000);
                        }
                        g.drawString(saListConv[iY], iX2 + 3, iY2 + (i * ifh) + 3, Graphics.LEFT | Graphics.TOP);
                    }
                }
            }
            if (bInputInhibit) g.fillRect(iMargin, iHeight - 1, iWidth - iMargin - iMargin, 1);
            if (bRepaint) paint(g);
        }
    }
}
